/* controlpointuiaction
 * $AUTHORS$, Tue Jun 6 2006
 *
 */
#ifndef CONTROLPOINTUIACTION_H
#define CONTROLPOINTUIACTION_H

#include "controlpoint.h"
#include <vector>

/**
	@author Herve Lombaert <herve.lombaert@polymtl.ca>
*/
class ControlPointUIAction{
public:
	ControlPointUIAction(std::vector<ControlPoint>* controlPoints);
	~ControlPointUIAction();
	
	bool selectControlPoint(float x, float y, float minDist); // return true if a point is selected (within 20 pixels of given position)
	void addControlPoint(float x, float y); // add a control point and select it
	
	void motion(float pos[0]); // move the control point and deform grid
	
private:
	std::vector<ControlPoint>* m_controlPoints; // pointer to the control points
	int m_index; // index of selected control point
	
private:
	double sqDistance(int index, float x, float y) const;
};

#endif
