/* deformimagewithcontrolpoint
 * $AUTHORS$, Tue Jun 6 2006
 *
 */
#ifndef DEFORMIMAGEWITHCONTROLPOINT_H
#define DEFORMIMAGEWITHCONTROLPOINT_H

#include "image.h"
#include "controlpoint.h"
#include "thinplatespline.h"
#include <vector>

/**
	@author Herve Lombaert <herve.lombaert@polymtl.ca>
*/
class DeformImageWithControlPoint{
public:
	DeformImageWithControlPoint(const Image* image, const std::vector<ControlPoint>* controlPoints);
	~DeformImageWithControlPoint();

	const int* getSize() const;
	unsigned char get(int i, int j) const;

public:
	void update();

private:
	const Image* m_image; // image to be deform
	const std::vector<ControlPoint>* m_controlPoints; // list of control points
	ThinPlateSpline* m_dx; // x displacement
	ThinPlateSpline* m_dy; // y displacement
};

#endif
