/* displaycontrolpoint
 * $AUTHORS$, Tue Jun 6 2006
 *
 */
 
#include "displaycontrolpoint.h"
#include <GL/gl.h>


DisplayControlPoint::DisplayControlPoint(const std::vector<ControlPoint>* controlPoints)
:	m_controlPoints(controlPoints)
{
}


DisplayControlPoint::~DisplayControlPoint()
{
}


void DisplayControlPoint::display()
{
	std::vector<ControlPoint>::const_iterator pb = m_controlPoints->begin();
	std::vector<ControlPoint>::const_iterator pe = m_controlPoints->end();
	
	while(pb != pe)
	{
		glPushMatrix();
		
		// Display a green square where the control point is
		glTranslatef(pb->x, pb->y, 0);
		glScalef(10,10,10);
		glColor4f(0,1,0,0.5);
		glBegin(GL_QUADS);
		glVertex3f(-0.5,-0.5,0);
		glVertex3f(-0.5,+0.5,0);
		glVertex3f(+0.5,+0.5,0);
		glVertex3f(+0.5,-0.5,0);
		glEnd();
		
		glPopMatrix();
		
		// Display a line between original and current control point position
		glColor4f(1,1,1,0.5); // white
		glBegin(GL_LINES);
		glVertex3f(pb->x,pb->y,0);
		glVertex3f(pb->x-pb->dx,pb->y-pb->dy,0);
		glEnd();
		
		glPushMatrix();
		
		// Display a red square where the control point was
		glTranslatef(pb->x-pb->dx, pb->y-pb->dy, 0);
		glScalef(5,5,5);
		glColor4f(1,0,0,0.5);
		glBegin(GL_QUADS);
		glVertex3f(-0.5,-0.5,0);
		glVertex3f(-0.5,+0.5,0);
		glVertex3f(+0.5,+0.5,0);
		glVertex3f(+0.5,-0.5,0);
		glEnd();
		
		glPopMatrix();
		
		// next control point
		++pb;
	}
}
