/* displayimage
 * $AUTHORS$, Tue Jun 6 2006
 *
 */
#ifndef DISPLAYIMAGE_H
#define DISPLAYIMAGE_H

/**
	@author Herve Lombaert <herve.lombaert@polymtl.ca>
*/
template <typename Image>
class DisplayImage{
public:
	DisplayImage(const Image* image);
	~DisplayImage();

	void display() const;

private:
	const Image* m_image;
};


#include <GL/gl.h>

template <typename Image>
DisplayImage<Image>::DisplayImage(const Image* image)
:	m_image(image)
{
}


template <typename Image>
DisplayImage<Image>::~DisplayImage()
{
}


template <typename Image>
void DisplayImage<Image>::display() const
{
	// Loop through each pixel
	const int* imageSize = m_image->getSize();
	for(int j=0; j<imageSize[1]; ++j)
		for(int i=0; i<imageSize[0]; ++i)
	{
		// Pixel intensity
		float intensity = (float)m_image->get(i,j)/255;
		
		glPushMatrix();
		
		// Display a square
		glTranslatef(i, j, 0);
		glScalef(1,1,1);
		glColor3f(intensity,intensity,intensity);
		glBegin(GL_QUADS);
		glVertex3f(-0.5,-0.5,0);
		glVertex3f(-0.5,+0.5,0);
		glVertex3f(+0.5,+0.5,0);
		glVertex3f(+0.5,-0.5,0);
		glEnd();
		
		glPopMatrix();
	}
}

#endif
