/* grid
 * Herve Lombaert, Tue Jun 6 2006
 *
 */

#ifndef GRID_H
#define GRID_H

/* control point */
struct Point {
	float pos[2];
};

/**
	@author Herve Lombaert <herve.lombaert@polymtl.ca>
*/
class Grid
{
public:
    Grid(int sizeX, int sizeY);
    ~Grid();

	void initOrthogonal(float spacing[2]);
	const int* getSize() const { return m_size; }
	const float* getPointPosition(int i, int j) const;
	void setPointPosition(int i, int j, float pos[2]);
	void getClosestControlPoint(float pos[2], int &i, int &j) const;

private:
	Point**	m_points; // control points (j,i)
	int m_size[2]; // number of control points (i,j)

};

#endif
